//
//  MY_Knob.h
//
//  Modified code based on auguiCocoa: Created by Airy Andr on Fri May 21 2004
//  Modified by Alex Kenis 2014
//

#import <Cocoa/Cocoa.h>

// Knob Cell
@interface MY_KnobCell : NSSliderCell {
    NSString *_backgroundName;
    NSString *_knobName;
    NSImage *_background;
    NSImage *_knob;
    
    double _minAngle, _maxAngle, _xOffset, _yOffset;
    BOOL _integralValues;
    
    double _lastTrackedValue;
}
- (void)setBackgroundName:(NSString *)name;
- (void)setKnobName:(NSString *)name;
- (void)setBackgroundImage:(NSImage *)image;
- (void)setKnobImage:(NSImage *)image;
- (NSString *)backgroundName;
- (NSString *)knobName;
- (NSImage *)background;
- (NSImage *)knob;

- (double)doubleValue;
- (double)minValue;
- (double)maxValue;
- (void)setDoubleValue:(double)val;
- (void)setMinValue:(double)min;
- (void)setMaxValue:(double)max;

- (double)minAngle;
- (double)maxAngle;
- (void)setMinAngle:(double)min;
- (void)setMaxAngle:(double)max;

- (double)xOffset;
- (double)yOffset;
- (void)setXOffset:(double)offset;
- (void)setYOffset:(double)offset;

- (BOOL)integralValues;
- (void)setIntegralValues:(BOOL)integral;
@end

// Knob
@interface MY_Knob : NSSlider {
}
- (void)setBackgroundName:(NSString *)name;
- (void)setKnobName:(NSString *)name;
- (void)setBackgroundImage:(NSImage *)image;
- (void)setKnobImage:(NSImage *)image;
- (NSString *)backgroundName;
- (NSString *)knobName;
- (NSImage *)background;
- (NSImage *)knob;

- (double)doubleValue;
- (float)floatValue;
- (double)minValue;
- (double)maxValue;
- (void)setDoubleValue:(double)val;
- (void)setFloatValue:(float)val;
- (void)setMinValue:(double)min;
- (void)setMaxValue:(double)max;

- (double)minAngle;
- (double)maxAngle;
- (void)setMinAngle:(double)min;
- (void)setMaxAngle:(double)max;

- (double)xOffset;
- (double)yOffset;
- (void)setXOffset:(double)offset;
- (void)setYOffset:(double)offset;

- (BOOL)integralValues;
- (void)setIntegralValues:(BOOL)integral;
@end
